package com.inca.npbusi.zx.websacon;

import com.inca.np.auth.ClientUserManager;
import com.inca.np.communicate.ClientRequest;
import com.inca.np.communicate.ParamCommand;
import com.inca.np.communicate.ServerResponse;
import com.inca.np.communicate.StringCommand;
import com.inca.np.demo.communicate.RemotesqlHelper;
import com.inca.np.gui.control.CFrame;
import com.inca.np.gui.control.DBTableModel;
import com.inca.np.gui.mde.CDetailModel;
import com.inca.np.gui.mde.CMasterModel;
import com.inca.np.gui.ste.CSteModel;
import com.inca.np.util.DecimalHelper;
import com.inca.np.util.SendHelper;
import com.inca.npx.mde.CMdeModelAp;
import com.inca.npx.ste.Apinfo;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Vector;
import org.apache.log4j.Category;

public class Web_sa_con_mde extends CMdeModelAp {
   private Category a = Category.getInstance(Web_sa_con_mde.class);
   private boolean b = true;

   public Web_sa_con_mde(CFrame var1, String var2) {
      super(var1, var2);
   }

   protected CMasterModel createMastermodel() {
      return new Web_sa_con_master(this.frame, this);
   }

   protected CDetailModel createDetailmodel() {
      return new Web_sa_con_detail(this.frame, this);
   }

   public String getMasterRelatecolname() {
      return "websacondocid";
   }

   public String getDetailRelatecolname() {
      return "websacondocid";
   }

   public String getSaveCommandString() {
      return "Web_sa_con_mde.网上订货合并管理";
   }

   protected int on_actionPerformed(String var1) {
      CSteModel var2;
      if ((var2 = this.getMasterModel()).getRowCount() == 0 && !var1.equals("关闭") && !var1.equals("查询")) {
         super.on_actionPerformed(var1);
      }

      if (!this.b && !var1.equals("关闭")) {
         super.on_actionPerformed(var1);
      }

      String var4;
      String var7;
      String var8;
      int var20;
      if (var1.equals("送审")) {
         StringBuffer var25 = new StringBuffer();
         if (!this.c()) {
            this.infoMessage("提示", "有单据未保存");
            return -1;
         }

         var4 = this.getApvalue("送审");
         if (!"1".equals(var4)) {
            this.infoMessage("提示", "您没有送审的权限！");
            return -1;
         }

         int[] var19 = this.mastermodel.getTable().getSelectedRows();

         for(var20 = 0; var20 < var19.length; ++var20) {
            var7 = var2.getItemValue(var19[var20], "usestatus");
            var8 = var2.getItemValue(var19[var20], "websacondocid");
            if (!var7.trim().equals("1") && !var7.trim().equals("6")) {
               this.infoMessage("提示", String.format("第%s行总单,只有正式或驳回状态可以送审", var19[var20] + 1));
               return -1;
            }

            var2.setRow(var19[var20]);
            var25.append(",").append(var8);
            this.a(var25.toString().substring(1));
         }
      } else {
         int var3;
         String var11;
         ServerResponse var12;
         StringCommand var14;
         String var15;
         int[] var16;
         StringCommand var17;
         StringBuffer var18;
         ParamCommand var21;
         LowGrossAppReturnDlg var22;
         ClientRequest var23;
         ParamCommand var24;
         if (var1.equals("业务审批")) {
            if (!this.c()) {
               this.infoMessage("提示", "有单据未保存");
               return -1;
            }

            var15 = this.getApvalue("业务审批");
            if (!"1".equals(var15)) {
               this.infoMessage("提示", "您没有业务审批的权限！");
               return -1;
            }

            var16 = this.getMasterModel().getTable().getSelectedRows();
            var3 = this.getMasterModel().getRow();
            var18 = new StringBuffer();
            var20 = 0;

            while(true) {
               if (var20 >= var16.length) {
                  var21 = new ParamCommand();
                  (var22 = new LowGrossAppReturnDlg(this.frame, "审批")).pack();
                  var22.setVisible(true);
                  if (!var22.isConfirm()) {
                     return -1;
                  }

                  var22.setParamValue(var21);
                  var8 = var21.getValue("appFlag");
                  var11 = var21.getValue("approvememo");
                  if (var8 == null || "".equals(var8)) {
                     this.infoMessage("提示", "请选择审批结果~~");
                     return -1;
                  }

                  if (var8 != null && var8.length() > 1) {
                     this.infoMessage("提示", "请选择正确的审批结果：只限本单通过、不通过或者驳回！");
                     return -1;
                  }

                  var15 = e();
                  (var23 = new ClientRequest()).addCommand(new StringCommand("Web_sa_con_mde.业务审批"));
                  (var24 = new ParamCommand()).addParam("appFlag", var8);
                  var24.addParam("approvememo", var11);
                  var24.addParam("websacondocids", var18.toString().substring(1));
                  var24.addParam("flag", var15);
                  var23.addCommand(var24);
                  var2 = null;

                  try {
                     this.a.info("发送命令开始---start");
                     var12 = SendHelper.sendRequest(var23);
                     this.a.info("发送命令完成---end");
                     var17 = (StringCommand)var12.commandAt(0);
                     var14 = (StringCommand)var12.commandAt(1);
                     if (var17.getString().startsWith("+OK")) {
                        for(var3 = 0; var3 < var16.length; ++var3) {
                           this.getMasterModel().setItemValue(var16[var3], "usestatus", var14.getString());
                           this.mastermodel.getDBtableModel().setdbStatus(var16[var3], 0);
                        }

                        this.infoMessage("提示", "业务审批成功！");
                        this.mastermodel.tableChanged();
                        this.detailmodel.doRequery();
                     } else if (var17.getString().startsWith("-Error")) {
                        this.a.error("Web_sa_con_mde.业务审批时发生异常,原因为：" + var17.getString());
                     }
                  } catch (Exception var10) {
                     this.a.error("Web_sa_con_mde.业务审批时发生异常,原因为：" + var10.getMessage());
                     var10.printStackTrace();
                  }
                  break;
               }

               var7 = this.getMasterModel().getItemValue(var3, "usestatus");
               var8 = this.getMasterModel().getItemValue(var3, "websacondocid");
               if (!"3".equals(var7)) {
                  this.infoMessage("提示", "第" + (var16[var20] + 1) + "条单据不是业务待审批状态，不能进行业务审批");
                  return -1;
               }

               var18.append(",").append(var8);
               ++var20;
            }
         } else if (var1.equals("财务审批")) {
            if (!this.c()) {
               this.infoMessage("提示", "有单据未保存");
               return -1;
            }

            var15 = this.getApvalue("财务审批");
            if (!"1".equals(var15)) {
               this.infoMessage("提示", "您没有财务审批的权限！");
               return -1;
            }

            var16 = this.getMasterModel().getTable().getSelectedRows();
            var3 = this.getMasterModel().getRow();
            var18 = new StringBuffer();
            var20 = 0;

            while(true) {
               if (var20 >= var16.length) {
                  var21 = new ParamCommand();
                  (var22 = new LowGrossAppReturnDlg(this.frame, "审批")).pack();
                  var22.setVisible(true);
                  if (!var22.isConfirm()) {
                     return -1;
                  }

                  var22.setParamValue(var21);
                  var8 = var21.getValue("appFlag");
                  var11 = var21.getValue("approvememo");
                  if (var8 == null || "".equals(var8)) {
                     this.infoMessage("提示", "请选择审批结果~~");
                     return -1;
                  }

                  if (var8 != null && var8.length() > 1) {
                     this.infoMessage("提示", "请选择正确的审批结果：只限本单通过、不通过或者驳回！");
                     return -1;
                  }

                  var15 = e();
                  (var23 = new ClientRequest()).addCommand(new StringCommand("Web_sa_con_mde.财务审批"));
                  (var24 = new ParamCommand()).addParam("appFlag", var8);
                  var24.addParam("approvememo", var11);
                  var24.addParam("websacondocids", var18.toString().substring(1));
                  var24.addParam("flag", var15);
                  var23.addCommand(var24);
                  var2 = null;

                  try {
                     this.a.info("发送命令开始---start");
                     var12 = SendHelper.sendRequest(var23);
                     this.a.info("发送命令完成---end");
                     var17 = (StringCommand)var12.commandAt(0);
                     var14 = (StringCommand)var12.commandAt(1);
                     if (var17.getString().startsWith("+OK")) {
                        for(var3 = 0; var3 < var16.length; ++var3) {
                           this.getMasterModel().setItemValue(var16[var3], "usestatus", var14.getString());
                           this.mastermodel.getDBtableModel().setdbStatus(var16[var3], 0);
                        }

                        this.infoMessage("提示", "财务审批成功！");
                        this.mastermodel.tableChanged();
                        this.detailmodel.doRequery();
                     } else if (var17.getString().startsWith("-Error")) {
                        this.a.error("Web_sa_con_mde.财务审批时发生异常,原因为：" + var17.getString());
                     }
                  } catch (Exception var9) {
                     this.a.error("Web_sa_con_mde.财务审批时发生异常,原因为：" + var9.getMessage());
                     var9.printStackTrace();
                  }
                  break;
               }

               var8 = this.getMasterModel().getItemValue(var3, "usestatus");
               var11 = this.getMasterModel().getItemValue(var3, "websacondocid");
               if ("3".equals(var8) || "8".equals(var8)) {
                  this.infoMessage("提示", "第" + (var16[var20] + 1) + "条单据需要业务审批通过，才能进行财务审批");
                  return -1;
               }

               if (!"5".equals(var8)) {
                  this.infoMessage("提示", "第" + (var16[var20] + 1) + "条单据不是待财务审批状态，不能进行财务审批");
                  return -1;
               }

               var18.append(",").append(var11);
               ++var20;
            }
         } else if (!var1.equals("生成销售订单")) {
            if (var1.equals("中止")) {
               if (!this.c()) {
                  this.infoMessage("提示", "当前有单据未保存");
                  return -1;
               }

               var4 = this.getApvalue("中止");
               if (!"1".equals(var4)) {
                  this.infoMessage("提示", "您没有此操作的权限！");
                  return -1;
               }

               this.a();
            }
         } else {
            if (!this.c()) {
               this.infoMessage("提示", "当前有单据未保存");
               return -1;
            }

            if ((var4 = this.b()) != null && !var4.trim().isEmpty()) {
               this.infoMessage("提示", var4);
               return -1;
            }

            var3 = 0;

            while(true) {
               if (var3 >= var2.getRowCount()) {
                  Map var13;
                  if ((var13 = this.d()).size() == 0) {
                     this.infoMessage("提示", "没有选中的行，不需要生成“销售订单数据”");
                     return -1;
                  }

                  this.a(var13);
                  break;
               }

               String var5 = var2.getItemValue(var3, "selectflag");
               String var6 = var2.getItemValue(var3, "usestatus");
               var7 = var2.getItemValue(var3, "storageid");
               if (var5.trim().equals("1")) {
                  if (DecimalHelper.comparaDecimal("4", var6) > 0) {
                     this.infoMessage("提示", String.format("第%s行：只有审批通过单据可生成销售订单", var3 + 1));
                     return -1;
                  }

                  if (var7 == null || var7.trim().isEmpty()) {
                     this.infoMessage("提示", String.format("第%s行：保管帐不能为空", var3 + 1));
                     return -1;
                  }
               }

               ++var3;
            }
         }
      }

      return super.on_actionPerformed(var1);
   }

   private void a() {
      int[] var1;
      if ((var1 = this.detailmodel.getTable().getSelectedRows()).length <= 0) {
         this.infoMessage("提示", "请选中细单进行中止操作~！");
      } else {
         StringBuffer var2 = new StringBuffer();

         String var5;
         for(int var3 = 0; var3 < var1.length; ++var3) {
            String var4 = this.detailmodel.getItemValue(var1[var3], "websacondtlid");
            var5 = this.detailmodel.getItemValue(var1[var3], "usestatus");
            if ("".equals(var5)) {
               var2.append(",").append(var4);
            }
         }

         ClientRequest var9;
         (var9 = new ClientRequest()).addCommand(new StringCommand("Web_sa_con_mde.中止"));
         ParamCommand var11;
         (var11 = new ParamCommand()).addParam("websacondtlids", var2.toString().substring(1));
         var9.addCommand(var11);
         var5 = null;

         try {
            ServerResponse var12;
            String var7 = ((StringCommand)(var12 = SendHelper.sendRequest(var9)).commandAt(0)).getString();
            ((StringCommand)var12.commandAt(1)).getString();
            if (var7.trim().startsWith("+OK")) {
               this.infoMessage("提示", "中止细单成功！");

               for(int var8 = 0; var8 < var1.length; ++var8) {
                  String var10 = this.detailmodel.getItemValue(var1[var8], "usestatus");
                  if ("".equals(var10)) {
                     this.detailmodel.setItemValue(var1[var8], "usestatus", "3");
                     this.detailmodel.setdbStatus(var1[var8], 0);
                  }
               }

               var7 = ((StringCommand)var12.commandAt(2)).getString();
               if (!"".equals(var7)) {
                  this.getMasterModel().setItemValue(this.getMasterModel().getRow(), "usestatus", var7);
                  this.getMasterModel().setdbStatus(this.getMasterModel().getRow(), 0);
               }

               this.detailmodel.tableChanged();
               this.getMasterModel().tableChanged();
            } else {
               var7 = var7.toString();
               this.infoMessage("提示", "-Error:" + var7);
            }
         } catch (Exception var6) {
            var6.printStackTrace();
         }
      }
   }

   private String b() {
      String var1 = "";
      CSteModel var2 = this.getMasterModel();

      for(int var3 = 0; var3 < var2.getRowCount(); ++var3) {
         if (var2.getItemValue(var3, "selectflag").trim().equals("1") && var2.getItemValue(var3, "storageid").trim().isEmpty()) {
            var1 = String.format("第%s行总单保管帐不能为空", var3 + 1);
            break;
         }
      }

      return var1;
   }

   private void a(Map<String, List<String>> var1) {
      StringBuffer var2 = new StringBuffer();
      String var3 = ",";
      String var4 = "__";
      String var5 = ";";
      Iterator var6 = var1.keySet().iterator();

      String var7;
      List var8;
      while(var6.hasNext()) {
         var7 = (String)var6.next();
         var2.append(var7);
         var2.append(var4);
         var8 = (List)var1.get(var7);

         for(int var11 = 0; var11 < var8.size(); ++var11) {
            var2.append((String)var8.get(var11));
            var2.append(var3);
         }

         var2.append(var5);
      }

      ClientRequest var12;
      (var12 = new ClientRequest()).addCommand(new StringCommand("Web_sa_con.创建销售订单"));
      var12.addCommand(new StringCommand(var2.toString()));
      var8 = null;

      try {
         if ((var7 = ((StringCommand)SendHelper.sendRequest(var12).commandAt(0)).getString()).trim().startsWith("+OK")) {
            this.infoMessage("提示", String.format("创建%s条销售订单单据", var1.size()));
            this.mastermodel.doRequery();
            this.detailmodel.doRequery();
         } else {
            CMasterModel var10;
            (var10 = this.mastermodel).getDBtableModel().getRecordThunk(var10.getRow()).setSaveresult(-1, var7);
         }
      } catch (Exception var9) {
         var9.printStackTrace();
      }
   }

   private boolean c() {
      boolean var1 = true;
      CSteModel var2;
      int var3 = (var2 = this.getMasterModel()).getRowCount();

      for(int var4 = 0; var4 < var3; ++var4) {
         if (var2.getdbStatus(var4) != 0) {
            var1 = false;
            break;
         }
      }

      var2.tableChanged();
      return var1;
   }

   private Map<String, List<String>> d() {
      CSteModel var1 = this.getMasterModel();
      new ArrayList();
      String var2 = null;
      HashMap var3 = new HashMap();

      for(int var4 = 0; var4 < var1.getRowCount(); ++var4) {
         if (var1.getItemValue(var4, "selectflag").trim().equals("1")) {
            var2 = var1.getItemValue(var4, "storageid");
            String var5 = var1.getItemValue(var4, "customerid");
            String var6 = var1.getItemValue(var4, "entryid");
            String var7 = var1.getItemValue(var4, "ddtype");
            String var8 = var1.getItemValue(var4, "tranposid");
            var5 = var5 + "_" + var2 + "_" + var6 + "_" + var8 + "_" + var7;
            Object var10;
            if (var3.containsKey(var5)) {
               var10 = (List)var3.get(var5);
            } else {
               var10 = new ArrayList();
               var3.put(var5, var10);
            }

            var1.setRow(var4);

            try {
               for(int var11 = 0; var11 < 20 && this.getDetailModel().getRowCount() == 0; ++var11) {
                  Thread.sleep(100L);
               }

               Thread.sleep(500L);
            } catch (InterruptedException var9) {
               var9.printStackTrace();
            }

            CSteModel var12 = this.getDetailModel();

            for(int var13 = 0; var13 < var12.getRowCount(); ++var13) {
               if (var12.getItemValue(var13, "selectflag").trim().equals("1")) {
                  var8 = var12.getItemValue(var13, "websacondtlid");
                  ((List)var10).add(var8);
               }
            }

            if (((List)var10).size() == 0) {
               var3.remove(var5);
            }
         }
      }

      return var3;
   }

   protected int on_beforemodifymaster(int var1) {
      return 0;
   }

   private void a(String var1) {
      String var2 = e();
      ClientRequest var3;
      (var3 = new ClientRequest()).addCommand(new StringCommand("Web_sa_con.送审"));
      var3.addCommand(new StringCommand(var1));
      var3.addCommand(new StringCommand(var2));
      var1 = null;

      try {
         if (!(var1 = ((StringCommand)SendHelper.sendRequest(var3).commandAt(0)).getString()).trim().startsWith("+OK")) {
            CMasterModel var7;
            (var7 = this.mastermodel).getDBtableModel().getRecordThunk(var7.getRow()).setSaveresult(-1, var1);
         } else {
            this.infoMessage("提示", "送审成功！");
            int[] var6 = this.getTable().getSelectedRows();

            for(int var5 = 0; var5 < var6.length; ++var5) {
               if ("1".equals(var2)) {
                  this.mastermodel.setItemValue(var6[var5], "usestatus", "3");
               } else {
                  label44: {
                     if (!"2".equals(var2)) {
                        if ("3".equals(var2)) {
                           this.mastermodel.setItemValue(var6[var5], "usestatus", "3");
                           break label44;
                        }

                        if ("4".equals(var2)) {
                           this.mastermodel.setItemValue(var6[var5], "usestatus", "5");
                           break label44;
                        }
                     }

                     this.mastermodel.setItemValue(var6[var5], "usestatus", "7");
                  }
               }

               this.mastermodel.setdbStatus(var6[var5], 0);
            }

         }
      } catch (Exception var4) {
         var4.printStackTrace();
      }
   }

   public Vector<Apinfo> getParamapinfos() {
      Vector var1;
      (var1 = new Vector()).add(new Apinfo("送审", ""));
      var1.add(new Apinfo("业务审批", ""));
      var1.add(new Apinfo("财务审批", ""));
      var1.add(new Apinfo("中止", ""));
      return var1;
   }

   private static String e() {
      String var0 = "";
      String var1 = null;
      String var2 = null;
      String var3 = null;
      Object var4 = null;
      var3 = null;

      try {
         var3 = "select nvl(t.value,0) value from Sys_npbusi_config  t where t.keyword ='busiApprove' and t.entryid = " + ClientUserManager.getCurrentUser().getEntryid();
         DBTableModel var6;
         if ((var6 = (new RemotesqlHelper()).doSelect(var3, 0, 1)) != null && var6.getRowCount() > 0) {
            var2 = var6.getItemValue(0, "value");
         }

         var3 = "select nvl(t.value,0) value from Sys_npbusi_config  t where t.keyword ='finanApprove' and t.entryid = " + ClientUserManager.getCurrentUser().getEntryid();
         if ((var6 = (new RemotesqlHelper()).doSelect(var3, 0, 1)) != null && var6.getRowCount() > 0) {
            var1 = var6.getItemValue(0, "value");
         }
      } catch (Exception var5) {
         var5.printStackTrace();
      }

      if ("1".equals(var2) && "1".equals(var1)) {
         var0 = "1";
      } else if (!"1".equals(var2) && !"1".equals(var1)) {
         var0 = "2";
      } else if ("1".equals(var2) && !"1".equals(var1)) {
         var0 = "3";
      } else if ("1".equals(var1) && !"1".equals(var2)) {
         var0 = "4";
      }

      return var0;
   }
}
